var requiredFields = new Array();

function URLDecode( encoded )
{
  var HEXCHARS = "0123456789ABCDEFabcdef"; 
  var plaintext = "";
  var i = 0;
  while (i < encoded.length) {
    var ch = encoded.charAt(i);
    if (ch == "+") {
      plaintext += " ";
      i++;
    } else if (ch == "%") {
      if (i < (encoded.length-2) 
          && HEXCHARS.indexOf(encoded.charAt(i+1)) != -1 
          && HEXCHARS.indexOf(encoded.charAt(i+2)) != -1 ) {
        plaintext += unescape( encoded.substr(i,3) );
        i += 3;
      } else {
        plaintext += "%[ERROR]";
        i++;
      }
    } else {
      plaintext += ch;
      i++;
    }
  }
  return plaintext;
}

function getURLParam(name) {
  if (location.search.length > 0) {
    var s = location.search.substring(1).split("&");
    for (var i = 0; i < s.length; i++) {
      var parts = s[i].split("=");
      if (parts.length > 1) {
        if (parts[0] == name) {
          return unescape(parts[1]);
        }
      }
    }
  }

  return "";
}

function fillFormFields()
{
  if (location.search.length > 0) {
    var s = location.search.substring(1).split("&");
    for (var i = 0; i < s.length; i++) {
      var parts = s[i].split("=");
      if (parts.length > 1) {
        var fieldObj = document.getElementById("contactData["+parts[0]+"]");

        if ( !fieldObj )
          continue;

        if ( fieldObj.tagName.toUpperCase() == "SELECT" ) {
          for ( i = 0; i < fieldObj.options.length; i++ ) {
            var option = fieldObj.options[i];

            if ( option.value == unescape(URLDecode(parts[1])) )
            {
              option.selected = true;
              continue;
            }
          }
        } else
          if ( fieldObj.tagName.toUpperCase() == "INPUT" && fieldObj.type == 'text' )
            fieldObj.value = unescape(URLDecode(parts[1]));
      }
    }
  }
}

function WriteErrorMessage()
{
  var Message = getURLParam("msg");
  Message = URLDecode( Message );
  document.write(Message);
}

function InitView()
{
  var Err = getURLParam("err");
  if ( Err.length ) {
    var errBlock = document.getElementById('errorblock');

    if ( errBlock )
      errBlock.style.display = "block";

    var field = getURLParam("field");
    if ( field.length ) {
      var fieldObj = document.getElementById("contactData["+field+"]");

      if ( fieldObj ) {
        try
        {
          fieldObj.focus();
        }
        catch (e)
        {
        }
      }
    }

    fillFormFields();

    return;
  }

  var Success = getURLParam("success");
  if ( Success.length ) {
    var successBlock = document.getElementById('successblock');
    if ( successBlock )
      successBlock.style.display = "block";

    var DoubleOptIn = getURLParam("doptin");
    if ( DoubleOptIn.length ) {
      var doubleOptInBlock = document.getElementById('doptinblock');
      if ( doubleOptInBlock )
        doubleOptInBlock.style.display = "block";

      var emailValue = getURLParam("email");
      var emailLabel = document.getElementById('emaillabel');
      if ( emailLabel )
        emailLabel.innerText = URLDecode(emailValue);
    }

    var formBlock = document.getElementById('formblock');
    if ( formBlock )
      formBlock.style.display = "none";
  }
}

function ValidateForm()
{
  for ( var i = 0; i < requiredFields.length; i++ ) {
    var fieldName = requiredFields[i];

    var fieldObj = document.getElementById("contactData["+fieldName+"]");
    if (fieldObj)
    {
      if ( fieldObj.tagName.toUpperCase() == "INPUT" ) {
        if ( !fieldObj.value.length )
        {
          alert("Please fill required fields");
          fieldObj.focus();
          return false;
        }
      } else {
        if ( fieldObj.tagName.toUpperCase() == "SELECT" ) {
          for ( j = 0; j < fieldObj.options.length; j++ ) {
            var option = fieldObj.options[j];

            if ( option.selected && !option.value.length )
            {
              alert("Please fill required fields");
              fieldObj.focus();
              return false;
            }
          }
        }
      }
    }
  }

  return true;
}